package rip.iwakura.civil;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import io.papermc.paper.plugin.lifecycle.event.types.LifecycleEvents;
import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.JDABuilder;
import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.utils.messages.MessageCreateBuilder;
import net.dv8tion.jda.api.utils.messages.MessageCreateData;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextDecoration;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import rip.iwakura.civil.events.ChatHandler;
import rip.iwakura.civil.events.TeamChatHandler;
import rip.iwakura.civil.commands.Team;
import rip.iwakura.civil.events.JoinHandler;
import rip.iwakura.civil.types.CivilPlayer;

public class Core extends JavaPlugin {
    public Database database;
    public Discord discord;

    public java.util.List<Player> teamChatToggled;

    public Component renderTeamChat(CivilPlayer p, Component message) {
        return Component.text("TEAM")
                .color(NamedTextColor.BLUE)
                .decoration(TextDecoration.BOLD, true)
                .appendSpace()
                .append(Component.text(p.getName())
                        .append(Component.text(": "))
                        .append(message)
                        .color(NamedTextColor.WHITE).decoration(TextDecoration.BOLD, false));
    }

    public Component renderTeamChat(User author, String message) {
        return Component.text("TEAM")
                .color(NamedTextColor.BLUE)
                .decoration(TextDecoration.BOLD, true)
                .append(Component.text(" Discord", NamedTextColor.BLUE).decoration(TextDecoration.BOLD, false)
                        .appendSpace()
                        .append(Component.text(author.getName())
                                .append(Component.text(": "))
                                .append(Component.text(message))
                                .color(NamedTextColor.WHITE).decoration(TextDecoration.BOLD, false)));
    }

    public void sendTeamMessage(CivilPlayer author, Component message) throws SQLException {
        Component deserializedMessage = renderTeamChat(author, message);
        discord.sendMessage(author, PlainTextComponentSerializer.plainText().serialize(message));
        for (CivilPlayer member : database.getAllPlayers(author.getTeam())) {
            try {
                Player player = Bukkit.getPlayer(member.getName());

                if (player == null || !player.isOnline())
                    continue;

                player.sendMessage(deserializedMessage);
            } catch (Exception e) {
                continue;
            }
        }
    }

    @Override
    public void onEnable() {
        getLogger().info("Hello world! We are booting up...");

        saveDefaultConfig();

        teamChatToggled = new ArrayList<>();

        try {
            this.database = new Database(getConfig().getString("database.url"), this);
        } catch (SQLException e) {
            getLogger().log(Level.SEVERE, e.getMessage());
            Bukkit.getPluginManager().disablePlugin(this);
        }

        this.discord = new Discord(this);
        discord.connect(getConfig().getString("discord.token"));

        Team teamCommand = new Team(this);

        this.getLifecycleManager().registerEventHandler(LifecycleEvents.COMMANDS, commands -> {
            commands.registrar().register(teamCommand.getCommand());
        });

        getServer().getPluginManager().registerEvents(new JoinHandler(database), this);
        getServer().getPluginManager().registerEvents(new ChatHandler(this), this);
        getServer().getPluginManager().registerEvents(new TeamChatHandler(this), this);
    }
}
