package rip.iwakura.civil.discord;

import java.sql.SQLException;
import java.util.List;
import java.util.logging.StreamHandler;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import net.dv8tion.jda.api.events.interaction.command.CommandAutoCompleteInteractionEvent;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import net.dv8tion.jda.api.interactions.commands.Command;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import rip.iwakura.civil.Core;
import rip.iwakura.civil.types.CivilTeam;

/**
 * LinkCommand
 */
public class LinkCommand extends ListenerAdapter {
    private Core core;

    public LinkCommand(Core core) {
        this.core = core;
    }

    @Override
    public void onSlashCommandInteraction(SlashCommandInteractionEvent event) {
        try {
            if (event.getName().equals("link")) {
                core.database.linkChannel(core.database.getTeam(event.getOption("team").getAsString()),event.getChannel().asTextChannel());
                event.reply("Successfully linked channel to team chat.").queue();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onCommandAutoCompleteInteraction(CommandAutoCompleteInteractionEvent event) {
        try {
            if (event.getName().equals("link") && event.getFocusedOption().getName().equals("team")) {
                List<String> teamNames = core.database.getAllTeams().stream().map(CivilTeam::getName).collect(
                        Collectors.toList());

                List<Command.Choice> options = teamNames.stream()
                    .filter(name -> name.startsWith(event.getFocusedOption().getValue()))
                    .map(name -> new Command.Choice(name, name)).collect(Collectors.toList());

                event.replyChoices(options).queue();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
