package rip.iwakura.civil.events;

import java.sql.SQLException;
import java.util.logging.Level;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

import io.papermc.paper.chat.ChatRenderer;
import io.papermc.paper.event.player.AsyncChatEvent;
import net.kyori.adventure.audience.Audience;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.minimessage.MiniMessage;
import rip.iwakura.civil.Core;
import rip.iwakura.civil.Database;

public class ChatHandler implements Listener, ChatRenderer {
    private Core core;
    private Database database;

    public ChatHandler(Core core) {
        this.core = core;
        this.database = core.database;
    }

    @EventHandler
    public void chatHandler(AsyncChatEvent event) {
        event.renderer(this);
    }

    @Override
    public Component render(Player source, Component sourceDisplayName, Component message, Audience viewer) {
        String prefix = null;

        try {
            prefix = database.getPlayer(source).getTeam().getPrefix();
        } catch (SQLException e) {
            core.getLogger().log(Level.WARNING, e.getMessage());;
        } catch (NullPointerException e) {
        }

        if (prefix == null) prefix = "";

        return MiniMessage.miniMessage()
            .deserialize(prefix)
            .append(sourceDisplayName)
            .append(Component.text(": "))
            .append(message);
    }
}
