package rip.iwakura.civil.events;

import java.sql.SQLException;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;

import io.papermc.paper.chat.ChatRenderer;
import io.papermc.paper.event.player.AsyncChatEvent;
import net.kyori.adventure.audience.Audience;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import rip.iwakura.civil.Core;
import rip.iwakura.civil.Database;
import rip.iwakura.civil.types.CivilPlayer;

public class TeamChatHandler implements Listener {
    private Core core;
    private Database database;

    public TeamChatHandler(Core core) {
        this.core = core;
        this.database = core.database;
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void chatHandler(AsyncChatEvent event) throws SQLException {
        if (core.teamChatToggled.contains(event.getPlayer())) {
            CivilPlayer p = database.getPlayer(event.getPlayer());

            core.sendTeamMessage(p, MiniMessage.miniMessage()
                    .deserialize(PlainTextComponentSerializer.plainText().serialize(event.message())));
            event.setCancelled(true);
        }
    }
}
