package rip.iwakura.civil.types;

import org.bukkit.Location;

import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

import rip.iwakura.civil.Core;

@DatabaseTable(tableName = "teams")
public class CivilTeam {
    @DatabaseField(id = true)
    private String name;

    @DatabaseField(canBeNull = false)
    private String prefix;

    @DatabaseField(canBeNull = true)
    private Long channel;

    @DatabaseField(canBeNull = true)
    private String webhook;

    @DatabaseField(canBeNull = true)
    private double home_x;

    @DatabaseField(canBeNull = true)
    private double home_y;

    @DatabaseField(canBeNull = true)
    private double home_z;

    @DatabaseField(canBeNull = true)
    private String home_world;

    public CivilTeam() {
    }

    public CivilTeam(String name, String prefix) {
        this.name = name;
        this.prefix = prefix;
    }

    public String getName() {
        return name;
    }

    public String getPrefix() {
        return prefix;
    }

    public void setHome(Location home) {
        this.home_x = home.x();
        this.home_y = home.y();
        this.home_z = home.z();
        this.home_world = home.getWorld().getName();
    }

    public Location getHome(Core core) {
        return new Location(core.getServer().getWorld(home_world), home_x, home_y, home_z);
    }

    public void setChannel(Long channel) {
        this.channel = channel;
    }

    public Long getChannel() {
        return channel;
    }

    public void setWebhook(String webhook) {
        this.webhook = webhook;
    }

    public String getWebhook() {
        return webhook;
    }
}
